
import com.vladium.utils.ClassLoaderRegistry;
import com.vladium.utils.ClassScope;

// ----------------------------------------------------------------------------
/**
 * A simple test driver for (@link com.vladium.utils.ClassScope} API. See the
 * article for more details.
 * 
 * @see com.vladium.utils.ClassScope
 * 
 * @author (C) <a href="http://www.javaworld.com/columns/jw-qna-index.shtml">Vlad Roubtsov</a>, 2003
 */
public
class Main
{
    // public: ................................................................

    public static void main (final String [] args)
    {
        // load some dummy classes just to make things more interesting:
        new Object () {};
        new Object () {};

        // option (1): manually enumerating class loaders
//        final ClassLoader appLoader = ClassLoader.getSystemClassLoader ();
//        final ClassLoader extLoader = appLoader.getParent ();        
//        final ClassLoader [] loaders = new ClassLoader [] {appLoader, extLoader};

        // option (2): enumerating class loaders for all classes on the call stack
        final ClassLoader [] loaders = ClassScope.getCallerClassLoaderTree ();
        
        // option (3): enumerating class loaders using the registry
//        final ClassLoader [] loaders = ClassLoaderRegistry.getClassLoaders ();
        
        final Class [] classes = ClassScope.getLoadedClasses (loaders);
        for (int c = 0; c < classes.length; ++ c)
        {
            final Class cls = classes [c];

            System.out.println ("[" + cls.getName () + "]:");
            System.out.println ("  loaded by [" + cls.getClassLoader ().getClass ().getName () + "]");
            System.out.println ("  from [" + ClassScope.getClassLocation (cls) + "]");
        }
    }
    
    // protected: .............................................................

    // package: ...............................................................
    
    // private: ...............................................................

} // end of class
// ----------------------------------------------------------------------------
